#pragma once

//Universal USB backend


//Interface class------------------------------------------------------------------------
class IUniversalUSBBackend
{
public:
	virtual bool Open(const GUID &guid, unsigned short vendorId, unsigned short productId)=0;
	virtual void Close(void)=0;
	virtual bool IsOpened(void)=0;

	virtual bool ReadPipe(BYTE pipeId, BYTE* buffer, DWORD bufferSize, DWORD *transferredSize)=0;
	virtual bool WritePipe(BYTE pipeId, BYTE* buffer, DWORD bufferSize, DWORD *transferredSize)=0;
};
