#pragma once

#pragma warning(push)
#pragma warning(disable: 4995)

#include <vector>
#include <list>
#include <map>

#pragma warning(pop)

#include <boost/pool/pool.hpp>

#include "TSPacket.h"

class CTSPacketFilter
{
protected:
	std::vector<CTSPacketSectionAccumulator*> vPMT;//PMT̃XgPMTZNV~
	std::map<WORD, std::vector<WORD>> vvAllowedPIDList;//ʉ߂PID̃XgPMTvectorœZ߂
	CTSPacketSectionAccumulator PAT;//PAT̃ZNV~

	WORD pid_ECM;//ECMPID

	void vPMTclear(void);//vPMT̃NAƒgdelete
	bool ParseDescriptor(WORD containerPID, BYTE* desc, WORD size);

public:
	bool ParseAndCheckAllow(CTSPacket& packet);
	bool CheckAllow(CTSPacket& packet);
	void ParsePacket(CTSPacket& packet);

	void Clear(void);

	bool IsECM(CTSPacket& packet);

	CTSPacketFilter::CTSPacketFilter();
	CTSPacketFilter::~CTSPacketFilter();
};

/*


肩(*L߁`*)
class CTSPacketVector
{
protected:
	std::list<CTSPacket*> lPackets;

	unsigned int nDropPackets;

public:
	void Push(CTSPacket*);
	void Clear(void);

	unsigned int DropPackets(void){return this->nDropPackets;}
	unsigned int Size(void){return this->lPackets.size();}

	CTSPacketVector::CTSPacketVector();
	CTSPacketVector::~CTSPacketVector();
};

class CTSPacketParser
{
protected:
	std::vector<WORD> vFilteringPID;//Lb`PID̃Xg

	std::map<WORD, CTSPacketVector> mFilteredPackets;//Lb`TSPacket*PIDɕۊ

	unsigned int nAllPackets;//͂ꂽpP
	unsigned int nTruncatedPackets;//Lb`ȂpP̐

public:
	bool AddPacket(CTSPacket* packet);
	bool AddPacket(BYTE* packet);

	void Clear(void);

	void AddFilteringPID(WORD pid);
	void GetFilteringPID(std::vector<WORD>* vPids);
	bool IsFilteredPID(WORD pid);

	unsigned int GetAllPackets(void){return this->nAllPackets;};
	unsigned int GetTruncatedPackets(void){return this->nTruncatedPackets;};

	unsigned int GetPacketsCount(WORD pid);

	unsigned int GetDropPackets(WORD pid);
	unsigned int GetDropPackets(void);

	CTSPacketParser::CTSPacketParser();
};

*/