#pragma once

#include "TSPacket.h"

class COnesegPatGenerator
{
public:
	COnesegPatGenerator();

	CTSPacket* GetPAT(void);
	void ParsePacket(CTSPacket& Packet);

protected:
	static const BYTE frame_PAT[];

	bool generated;

	CTSPacket PAT;

	WORD transportStreamID_BE;
	WORD serviceID[9];
	BYTE cyclicCounter;

	void COnesegPatGenerator::ParseDescriptor(BYTE desc[], WORD size);

	void AddNIT(CTSPacket& NIT);
	void AddPMT(CTSPacket& PMT);
};

